<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\WorkflowModel;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class WorkflowService extends BaseService
{
	/**
     WorkflowService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new WorkflowModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request, $history = false)
	{
		$auth = json_decode($request->session()->get('auth'));

		$arrSelects = [
			"workflow.id as id",
			"workflow.tipeTransaksi as tipeTransaksi",
			"workflow.urlTransaksi as urlTransaksi",
			"workflow.namaTransaksi as namaTransaksi",
			"workflow.refId as refId",
			"workflow.dateUpdated as dateUpdated",
			"workflow.dateCreated as dateCreated",
			"workflow.requesterId as requesterId",
			"requesterId.name as requesterName",
			"workflow.approverId as approverId",
			"workflow.status as status",
			"pindahbarangio.id as ioID",
			"permintaanbarang.id as prID",
			"penggunaanmakanan.id as msID",
			"penerimaanmakanan.id as mrID",
			"pindahbarangsubinv.id as moID"
		];

		$this->model->joinRelationRequesterId()->getQuery()->select($arrSelects)
			->leftjoin("pindahbarangio", "pindahbarangio.ioNumber", "=", "workflow.refId")
			->leftjoin("permintaanbarang", "permintaanbarang.prNumber", "=", "workflow.refId")
			->leftjoin("pindahbarangsubinv", "pindahbarangsubinv.moNumber", "=", "workflow.refId")
			->leftjoin("penggunaanmakanan", "penggunaanmakanan.msNumber", "=", "workflow.refId")
			->leftjoin("penerimaanmakanan", "penerimaanmakanan.mrNumber", "=", "workflow.refId");

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("workflow.kapalId", "=", $auth->kapalId);
		}

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("workflow.dateCreated", "desc");
		}

		if ($history) {
			$this->model->getQuery()->where("workflow.status", ">", 0);
		} else {
			$this->model->getQuery()->where("workflow.status", "=", 0);
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return WorkflowModel
	 */
	public function show($id)
	{
		$model = $this->model->getQuery()->where("workflow.id", "=", $id)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return WorkflowModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$this->model->fill($input);
		if (!$this->model->save()) {
			throw new \Exception();
		}
		return $this->model;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return WorkflowModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$workflow = WorkflowModel::find($id);
		$workflow->fill($input);
		if (!$workflow->update()) {
			throw new \Exception();
		}
		return $workflow;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function approve($input)
	{
		$dateTimeApproved = date("Y-m-d H:i:s");
		$newInput = [
			"approverId" => $input["approverId"],
			"dateUpdated" => $dateTimeApproved,
			"date_updated" => $dateTimeApproved,
			"status" => $input["status"]
		];
		$Workflow = WorkflowModel::where("refId", $input["refId"]);
		if (!$Workflow->update($newInput)) {
			throw new \Exception();
		}

		$needSync = $Workflow->first();
		$sync = SyncHandlersModel::where("sync.local_id", "=", $needSync->id)
			->where("sync.table_name", "=", "workflow");
		if (!$sync->update(["need_sync" => 1])) {
			throw new \Exception();
		}
		return $Workflow;
	}
}
